<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.12.1/js/dataTables.bootstrap4.min.js"></script>
  <style>
    .pointer {cursor: pointer;}
  </style>
</head>
<body onload="onPageLoading()">
<div class="container">
  <div class="text-center mt-2 mb-2">
    <h2>F120 - Quản trị Order</h2>
  </div>
  <div class="jumbotron container">
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="voucherCodeInput">Loại Pizza</label>
      </div>
      <div class="col-sm-6">
        <select id="gPizzaTypeSelect" class="form-control">
          <option value="0">-- Chọn tất cả --</option>
        </select>
      </div>
      <div class="col-sm-3">
        <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
      </div>
    </div>
</div>

<div class="container">
  <table class="table table-bordered table-striped table-hover" id="order-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã order</th>
        <th>Loại Pizza</th>
        <th>Tên khách hàng</th>
        <th>Ngày đặt hàng</th>
        <th>Trạng thái</th>
        <th>Action</th>
      </tr>
    </thead>
  </table>
</div>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // mảng orders
  var gOrderObjects = [
      {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
      },
      {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
      },
      {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
      },
      {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
      },
      {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
      }
    ];
  
  // mảng pizza Type
  var gPizzaType = [
    {
      typeId: 10,
      typeName: "Hải Sản"
    },
    {
      typeId: 15,
      typeName: "Bò bít tết"
    },
    {
      typeId: 20,
      typeName: "Thịt gà"
    }
  ];
  
  // mảng các thuộc tính sẽ gắn lên datatable
  const gORDER_OBJ = ["stt", "orderCode", "gPizzaTypeId", "customerName", "date", "status", "action"];
  
  const gORDER_COL_STT = 0;
  const gORDER_COL_ORDER_CODE = 1;
  const gORDER_COL_PIZZA_TYPE = 2;
  const gORDER_COL_CUSTOMER_NAME = 3;
  const gORDER_COL_DATE = 4;
  const gORDER_COL_STATUS = 5;
  const gORDER_COL_ACTION = 6;
  
  var gSTT = 1;
  // khai báo DataTable và mapping columns
  var gOrderTable = $("#order-table").DataTable({
    columns: [
      {data: gORDER_OBJ[gORDER_COL_STT]},
      {data: gORDER_OBJ[gORDER_COL_ORDER_CODE]},
      {data: gORDER_OBJ[gORDER_COL_PIZZA_TYPE]},
      {data: gORDER_OBJ[gORDER_COL_CUSTOMER_NAME]},
      {data: gORDER_OBJ[gORDER_COL_DATE]},
      {data: gORDER_OBJ[gORDER_COL_STATUS]},
      {data: gORDER_OBJ[gORDER_COL_ACTION]}
    ],
    columnDefs: [
      {
        targets: gORDER_COL_STT,
        render: function() {
          return gSTT ++;
        }
      },
      {
        targets: gORDER_COL_PIZZA_TYPE,
        render: function(paramPizzaTypeId) {
          return getPizzaNameByTypeId(paramPizzaTypeId);
        }
      },
      {
        targets: gORDER_COL_ACTION,
        defaultContent: `
          <i class="fas fa-edit pointer" data-toggle="tooltip" title="Edit order"></i>
          <i class="fas fa-trash-alt pointer" data-toggle="tooltip" title="Delete order"></i>
        `
      }
    ]
  });

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $("#btn-filter-order").on("click", function() {
    onBtnFilterOrderClick();
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  function onPageLoading() {
    loadDataToOrderTable(gOrderObjects);
    loadDataToSelectPizzaType();
  }

  // hàm xử lý sự kiện nút filter order click
  function onBtnFilterOrderClick() {
    // Khai báo đối tượng để chứa dữ liệu filter
    var vFilterObj = {
      pizzaTypeId: 0
    };

    // B1: Thu thập dữ liệu filter
    thuThapDuLieuFilter(vFilterObj);
    // B2: validate (ko có)
    // B3: filter orders: đầu ra sẽ trả về 1 mảng các đơn hàng
    var vOrdersResult = [];
    vOrdersResult = filterOrders(vFilterObj);
    // B4: hiển thị dữ liệu sau khi filter lên table
    loadDataToOrderTable(vOrdersResult);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm trả về pizzaTypeName dựa vào typeId
  function getPizzaNameByTypeId(paramTypeId) {
    "use strict";
    var vPizzaTypeName = "";
    var vIndex = 0;
    var vIsTypeFound = false;
    while(!vIsTypeFound && vIndex < gPizzaType.length) {
      if(gPizzaType[vIndex].typeId === paramTypeId) {
        vIsTypeFound = true;
        vPizzaTypeName = gPizzaType[vIndex].typeName;
      }
      else {
        vIndex ++;
      }
    }
    return vPizzaTypeName;
  }
  
  // hàm để load dữ liệu vào order table
  function loadDataToOrderTable(paramOrderArr) {
    gSTT = 1;
    gOrderTable.clear();
    gOrderTable.rows.add(paramOrderArr);
    gOrderTable.draw();
  }

  function loadDataToSelectPizzaType() {
    var vSelectPizzaType =  $("#gPizzaTypeSelect");

    for(var bI = 0; bI < gPizzaType.length; bI ++) {
      $("<option>", {
        text: gPizzaType[bI].typeName,
        value: gPizzaType[bI].typeId
      }).appendTo(vSelectPizzaType);
    }
  }

  function thuThapDuLieuFilter(paramFilterObj) {
    paramFilterObj.pizzaTypeId = $("#gPizzaTypeSelect").val();
  }

  // hàm thực hiện lọc orders theo pizzaTypeId
  function filterOrders(paramFilterObj) {
    var vOrdersArr = [];
    // filter 
    vOrdersArr = gOrderObjects.filter(function(paramOrder) {
      return (paramOrder.gPizzaTypeId == paramFilterObj.pizzaTypeId || paramFilterObj.pizzaTypeId == 0 );
    });
    return vOrdersArr;
  }
</script>
</body>
</html>